package jp.ac.shibaura_it.ma15082;

import java.util.ArrayList;
import java.util.List;



import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.client.lib.TemplateWhisperFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Player;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Team;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;


public class WasabiPlayer extends AbstractRole implements Player{

	private String name;
	private Agent agent;
	private GameInfo gi;
	private Personality personality;
	//̉
	private WasabiAnalyzer wa;
	//_̏
	private List<PlayerInfo> view;
	//ϓIȐMx
	private ListMap<Agent,Double> score;
	private ListMap<ListMap<Agent,Double>,Double> scores;
	
	//TEl̃Xg
	private ListMap<Agent,Pair<Role,Double>> wolfs;
	private List<Agent> lunatics;
	//xE
	private Role myRole;

	private List<String> role_mess;
	private int skip_count;
	private double th;
	
	
	@Override
	public void initialize(GameInfo arg0, GameSetting arg1) {
		gi=arg0;
		agent=gi.getAgent();
		name="WASABI_"+gi.getAgent().getAgentIdx();
		view=null;
		score=new ListMap<Agent,Double>(16);
		scores=new ListMap<ListMap<Agent,Double>,Double>();
		double oe=0,co=0,ex=0,ag=0,ne=0;
		
		if(gi.getRole().getTeam()==Team.VILLAGER){
			oe=Tools.random()<0.5? Tools.random(0.2):1-Tools.random(0.2);
			co=Tools.random(0.2)+0.8;
			ex=Tools.random(0.3)+0.7;
			ag=Tools.random(0.3)+0.2;
			ne=Tools.random();
		}
		else{
			oe=Tools.random(0.2);
			co=Tools.random(0.3);
			ex=Tools.random(0.3)+0.7;
			ag=Tools.random(0.3)+0.6;
			ne=Tools.random(0.2);
		}
		
		personality=new Personality(oe,co,ex,ag,ne);
		
		wolfs=new ListMap<Agent,Pair<Role,Double>>();
		lunatics=new ArrayList<Agent>();

		wa=new WasabiAnalyzer(gi,arg1,personality);
		LineInfo.wa=wa;
		role_mess=new ArrayList<String>();
		
		//NOTE:x̌vZ͂łȂ
		//TxȂ狶lx
		if(gi.getRole()==Role.WEREWOLF){
			for(Agent a : gi.getAgentList()){
				if(gi.getRoleMap().get(a)==Role.WEREWOLF){
					wolfs.put(a,null);
				}
			}
		}
		else if(gi.getRole()==Role.POSSESSED){
			myRole=Role.SEER;
		}
		th=0;
		
		
		return;
	}


	@Override
	public void update(GameInfo arg0) {
		gi=arg0;
		wa.update(gi);
		view=new ArrayList<PlayerInfo>(16);
		scores.clear();
		for(PlayerInfo p : wa.getPlayerInfos()){
			PlayerInfo pi=new PlayerInfo(p);
			view.add(pi);
			pi.setCertain(0.0);
			if(pi.getAgent().equals(agent)){
				score.put(pi.getAgent(),1.0);//͐΂ɔ
			}
			
			else{
				score.put(pi.getAgent(), Tools.random()*personality.getWeightRandom()+(1-personality.getWeightRandom())*wa.getScore(agent,pi.getAgent(),gi.getDay()));//ϓIȋ^
			}
			
		}
		
		
		
		for(LineInfo li : wa.getLineInfos()){
			ListMap<Agent,Double> lm=li.getScoreList();
			scores.add(lm, li.getScore() * lm.get(agent));
		}

		Tools.unit(scores);

		int count=0;
		th=0;
		for(PlayerInfo pi : view){
			Agent p=pi.getAgent();
			double p_score=score.get(p);
			for(int i=0;i<scores.size();++i){
				double t_score =scores.getKey(i).get(p);
				pi.setCertain(pi.getCertain()+scores.getValue(i)*calcCertain(t_score,p_score,personality.getWeightSubjective()));
			}
			if(pi.isAlive() && !agent.equals(pi.getAgent())){
				th+=pi.getCertain();
				count++;
			}

		}

		th/=count;
		
		for(PlayerInfo pi : view){
			if(pi.getRole().getTeam()==Team.WEREWOLF){
				pi.setCertain(0);
			}
		}
		
		return;
	}
	

	final private static double calcCertain(double a,double b,double r){
		double f=3*r*a*(1-a);
		return (f*b+(1-f)*a);
	}




	//NOTE:mess,role_messdayStartŐݒ
	//role_mess͂ǂCO,ʂ2
	//0ڂ͂ȂɂȂ
	//1ڂKCO
	@Override
	public void dayStart() {
		Judge j;		
		if(gi.getDay()<=0){
			//mess=getTalkList();
			return;
		}
		role_mess.clear();
		switch(gi.getRole()){
		case SEER:
			j=gi.getDivineResult();
			role_mess.add(TemplateTalkFactory.comingout(agent,Role.SEER));
			if(j!=null){
				role_mess.add(TemplateTalkFactory.divined(j.getTarget(),j.getResult()));
			}
			break;
		case MEDIUM:
			j=gi.getMediumResult();
			role_mess.add(TemplateTalkFactory.comingout(agent,Role.MEDIUM));
			if(j!=null){
				role_mess.add(TemplateTalkFactory.inquested(j.getTarget(),j.getResult()));
			}
			break;
		case POSSESSED:
			if(myRole==Role.SEER){
				wolf_divine();
			}
			break;
		case WEREWOLF:
			break;
		default:
			break;
			
		}
		
		skip_count=0;
	}

	public void wolf_divine(){
		ListMap<Agent,Double> divinelist=getDivineList();
		Agent p=Tools.selectKey(divinelist);
		if(p==null){
		List<Agent> as=gi.getAliveAgentList();
		while(p==null){
			p=as.get(Tools.rand(as.size()));
			if(p==agent){
				p=null;
			}
		}
		}
		
		double a=0;
		PlayerInfo temp=null;
		for(PlayerInfo pi : view){
			if(pi.getAgent().equals(p)){
				a=pi.getCertain();
				temp=pi;
				break;
			}
		}
		//_̐Mx猋ʂ߂
		Species c=Species.HUMAN;
		if(temp.getRole()!=Role.VILLAGER){
			JudgeInfo j=wa.getSeerInfo(agent);
			if(j!=null){
				int d=j.blackNum();
				c=(d>=3?Species.HUMAN:Species.WEREWOLF);
			}
			else{
				c=Species.WEREWOLF;
			}
		}
		else{
			c=((Tools.random())<a) ? Species.HUMAN:Species.WEREWOLF;
		}
		//System.err.println(p+" "+a+" "+c);
		role_mess.add(TemplateTalkFactory.comingout(agent,Role.SEER));
		role_mess.add(TemplateTalkFactory.divined(p,c));
		return;
	}
	
	
	
	@Override
	public void finish() {
	}
	
	@Override
	public String getName() {
		return name;
	}


	

	private Agent getOne(boolean flag){
		List<Agent> list=gi.getAliveAgentList();
		list.remove(agent);
		if(flag){
			for(Agent a : wolfs.keySet()){
				list.remove(a);
			}
		}
		return list.get(Tools.rand(list.size()));

	}
	
	@Override
	public Agent vote() {
		ListMap<Agent,Double> votelist=getVoteList();
		Agent p=Tools.selectKey(votelist);
		if(p==null){
			p=getOne(false);
		}
		
		return p;
	}



	//NOTE:CӂŎ̂Ȃo
	//4l̂Ƃ͎̂Ȃɂ
	//5l̂Ƃɓ[ňlޏꂷ邩cl5lŎ̂Ȃ
	@Override
	public Agent attack() {
	if(gi.getAliveAgentList().size()==5){
		return null;
	}
	ListMap<Agent,Double> attacklist=getAttackList();
	Agent p=Tools.selectKey(attacklist);
	if(p==null){
		p=getOne(true);
	}
	
	return p;
	}


	@Override
	public Agent divine() {
	ListMap<Agent,Double> divinelist=getDivineList();
	Agent p=Tools.selectKey(divinelist);
	if(p==null){
		p=getOne(false);
	}
	return p;
	}


	@Override
	public Agent guard() {
		ListMap<Agent,Double> guardlist=getGuardList();
		Agent p=Tools.selectKey(guardlist);
		if(p==null){
			p=getOne(false);
		}
		return p;
	}





	//NOTE:bZ[WgetTalkLstł܂Ƃ߂Ď擾getTalkŖ擾
	//talk11bZ[WMłȂAupdatẻelł
	@Override
	public String talk() {
		if(role_mess!=null && role_mess.size()>0){
			return role_mess.remove(0);
		}
		return getTalk();
	}

	@Override
	public String whisper() {
		return getWhisper();
	}

	
	//NOTE:EbnŖ̂`FbN
	public void searchLunatics(){
		lunatics.clear();
		for(JudgeInfo ji : wa.getSeerInfos()){
			for(Judge j : ji.getJudgeList()){
				if(wolfs.containsKey(j.getTarget())){
					if(j.getResult()==Species.HUMAN){
						lunatics.add(ji.getAgent());
						break;
					}
				}
				else{
					if(j.getResult()==Species.WEREWOLF){
						lunatics.add(ji.getAgent());
						break;
					}
				}
			}
		}
		for(JudgeInfo ji : wa.getMediumInfos()){
			for(Judge j : ji.getJudgeList()){
				if(wolfs.containsKey(j.getTarget())){
					if(j.getResult()==Species.HUMAN){
						lunatics.add(ji.getAgent());
						break;
					}
				}
				else{
					if(j.getResult()==Species.WEREWOLF){
						lunatics.add(ji.getAgent());
						break;
					}
				}
			}
		}
				
		return;
	}

	

	
	


	public ListMap<Agent,Double> getAliveList(){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				ret.add(pi.getAgent(), 1.0);
			}
			else{
				ret.add(pi.getAgent(), 0.0);
			}
		}
		return ret;
	}

	//true->white false->black
	public ListMap<Agent,Double> getAliveList(boolean flag){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean nonzero=false;
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				double x=(flag?pi.getCertain():1.0-pi.getCertain());
				if(x>0){
					nonzero=true;
				}
				ret.add(pi.getAgent(),x);
			} else {
				ret.add(pi.getAgent(),0.0);
			}
		}

		if(nonzero){
			return ret;
		}
		return getAliveList();

	}




	
	public ListMap<Agent,Double> getVoteList(){
		ListMap<Agent,Double> ret;
		boolean flag;
		ret=getAliveList(false);
		
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				//c̐lƂɂ͐肢t͂ɂ
				if(pi.getRole()==Role.SEER){
					double a=((double)(wa.seerSize()-1.0)/gi.getAliveAgentList().size());
					double r=ret.get(pi.getAgent());
					double th=1.0/gi.getAliveAgentList().size();
					
					if(r<th || (1-th)<r){
						ret.put(pi.getAgent(),r);
					}
					else if(r*a>1){
						ret.put(pi.getAgent(),1.0);
					}
					else{
						ret.put(pi.getAgent(),r*a);
					}
					
				}
			}
			
			else{
				ret.put(pi.getAgent(),0.0);				
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,6,1);

		
		if(flag){
			return ret;
		}
		ret=getAliveList(false);
		ret.put(agent,0.0);
		return ret;
	}
	
	public ListMap<Agent,Double> getGuardList(){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean flag;
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				double a=0.1;
				if(pi.getRole()==Role.SEER){
					a*=wa.getAliveSize()/2.0;
				}
				else if(pi.getRole()==Role.MEDIUM){a*=2;}
				ret.put(pi.getAgent(),pi.getCertain()*a);
			}
			else{
				ret.put(pi.getAgent(),0.0);
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,3,1);
		if(flag){
			return ret;
		}
		ret=getAliveList(true);
		ret.put(agent,0.0);
		return ret;
	}



	public ListMap<Agent,Double> getAttackList(){
		searchLunatics();
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean flag;
		for(PlayerInfo pi : view){
			if(wolfs.containsKey(pi.getAgent())){
				ret.put(pi.getAgent(),0.0);
			}
			else if(pi.isAlive()){
				if(pi.getRole()==Role.SEER){
					ret.put(pi.getAgent(), pi.getCertain()*2);
				}
				else{
					ret.put(pi.getAgent(),pi.getCertain());
				}
			}			
			else{
				ret.put(pi.getAgent(),0.0);				
			}
		}
		for(Agent s : lunatics){
			ret.put(s, 0.0);
		}
		flag=Tools.cutList(ret,5,1);
		if(flag){
			return ret;
		}
		ret=getAliveList(true);
		for(Agent s : lunatics){
			ret.put(s, 0.0);
		}
		for(Agent s : wolfs.keyList()){
			ret.put(s,0.0);
		}
		return ret;
	}



	public ListMap<Agent,Double> getDivineList(){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean flag=false;
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				if(pi.isChecked()){
					ret.put(pi.getAgent(),0.0);
				}
				else if(pi.getRole()==Role.MEDIUM || pi.getRole()==Role.SEER){
					ret.put(pi.getAgent(),0.0);
				}
				else{
					double x=pi.getCertain()*(1-pi.getCertain());
					ret.put(pi.getAgent(),x);
				}

			}
			else{
				ret.put(pi.getAgent(),0.0);
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret, 3, 1);
		if(flag){
			return ret;
		}


		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				if(pi.isChecked(agent)){
					ret.put(pi.getAgent(),0.0);
				}
				else if(pi.getRole()==Role.MEDIUM || pi.getRole()==Role.SEER){
					ret.put(pi.getAgent(),0.0);
				}
				else{
					double x=pi.getCertain()*(1-pi.getCertain());
					ret.put(pi.getAgent(),x);
				}

			}
			else{
				ret.put(pi.getAgent(),0.0);
			}

		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,3,1);
		if(flag){
			return ret;
		}


		ret=getAliveList(false);
		for(PlayerInfo pi : view){
			if(pi.isChecked(agent)){
				ret.put(pi.getAgent(), 0.0);
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,2,1);
		if(flag){
			return ret;
		}

		ret=getAliveList();
		ret.put(agent,0.0);
		return ret;
	}




	public ListMap<Agent,Double> getWhiteList(double th){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		for(PlayerInfo pi : view){
			if(pi.isDead()){
				ret.put(pi.getAgent(),0.0);
			}
			else if(pi.getAgent().equals(agent)){
				ret.put(pi.getAgent(),0.0);
			}
			else if(th<pi.getCertain()){
				ret.put(pi.getAgent(),pi.getCertain());
			}
			else{
				ret.put(pi.getAgent(), 0.0);
			}
		}
		return ret;
	}


	public ListMap<Agent,Double> getBlackList(double th){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		for(PlayerInfo pi : view){
			if(pi.isDead()){
				ret.put(pi.getAgent(),0.0);
			}
			else if(pi.getAgent().equals(agent)){
				ret.put(pi.getAgent(),0.0);
			}
			else if(pi.getCertain()<th){
				ret.put(pi.getAgent(),1-pi.getCertain());
			}
			else{
				ret.put(pi.getAgent(), 0.0);
			}
		}

		return ret;
	}


	
	//NOTE:̖͂EA͘TłƐ锭
	
	public String getTalk(){
		String ret=skip_count>2?TemplateTalkFactory.over():TemplateTalkFactory.skip();
		Agent to;
		Role role;
		if(personality.getWeightVolume()<Tools.random()){
			skip_count++;
			return ret;
		}
		if(Tools.random()<personality.getWeightTalkWhite()){
			to=Tools.selectKey(getWhiteList(th));
			role=Role.VILLAGER;
			for(PlayerInfo pi : view){
				if(pi.getAgent().equals(to)){
					role=pi.getRole();
					break;
				}
			}
		}
		else{
			to=Tools.selectKey(getBlackList(th));
			role=Role.WEREWOLF;
		}
		if(to!=null){
			ret=(TemplateTalkFactory.estimate(to,role));
		}
		
		return ret;
	}
	
	
	
	public String getWhisper(){
		return TemplateWhisperFactory.over();
		//NOTE:ǂȍs邩Al̈ʒuɂĘb
		/*
		Agent p;
			
		String ret=skip_count>2?TemplateWhisperFactory.over():TemplateWhisperFactory.skip();
		if(personality.getWeightVolume()<Tools.random()){
			skip_count++;
			return ret;
		}
		
		switch(Tools.rand(6)){
		case 0://lɂ
		if(lunatics.size()>0){
			ret=TemplateWhisperFactory.estimate(lunatics.get(Tools.rand(lunatics.size())), Role.POSSESSED);
		}
		break;
		case 1://Pɂ
			p=Tools.selectKey(getAttackList());
			if(p!=null){
				ret=TemplateWhisperFactory.attack(p);
			}
			break;
		case 2://肢ɂ
			p=Tools.selectKey(getDivineList());
			if(p!=null){
				Species s=wolfs.containsKey(p)?Species.WEREWOLF:Species.HUMAN;
				ret=TemplateWhisperFactory.divined(p,s);
			}
			break;
		case 3://qɂ
			p=Tools.selectKey(getGuardList());
			if(p!=null){
				ret=TemplateWhisperFactory.guarded(p);
			}
			break;
		case 4://[ɂ
			p=Tools.selectKey(getVoteList());
			if(p!=null){
				ret=TemplateWhisperFactory.vote(p);
			}
			break;
		default:
			break;
		}
		return ret;
		*/
	}
	
	
	
}

